version: "3"
services:
  frontend:
    image: registry.gitlab.com/ykycha.kolot/microservice-app/frontend:frontend
    environment:
      PORT: 8080
      AUTH_API_ADDRESS: http://auth-api:8081
      TODOS_API_ADDRESS: http://todos-api:8082
      ZIPKIN_URL: http://zipkin:9411/api/v2/spans
    ports:
      - 8080:8080
    depends_on:
      - zipkin
      - auth-api
      - todos-api
      - users-api

  auth-api:
    image: registry.gitlab.com/ykycha.kolot/microservice-app/auth-api:auth-api
    environment:
      AUTH_API_PORT: 8081
      JWT_SECRET: myfancysecret
      USERS_API_ADDRESS: http://users-api:8083
      ZIPKIN_URL: http://zipkin:9411/api/v2/spans
    depends_on:
      - zipkin
      - users-api

  todos-api:
    image: registry.gitlab.com/ykycha.kolot/microservice-app/todos-api:todos-api
    environment:
      TODO_API_PORT: 8082
      JWT_SECRET: myfancysecret
      REDIS_HOST: redis-queue
      REDIS_PORT: 6379
      REDIS_CHANNEL: log_channel
      ZIPKIN_URL: http://zipkin:9411/api/v2/spans
    depends_on:
      - zipkin
      - redis-queue

  users-api:
    image: registry.gitlab.com/ykycha.kolot/microservice-app/users-api:users-api
    environment:
     SERVER_PORT: 8083
     JWT_SECRET: myfancysecret
     SPRING_ZIPKIN_BASE_URL: http://zipkin:9411
    depends_on:
      - zipkin
     
  log-message-processor:
    image: registry.gitlab.com/ykycha.kolot/microservice-app/log-message-processor:log-message-processor
    environment:
      REDIS_HOST: redis-queue
      REDIS_PORT: 6379
      REDIS_CHANNEL: log_channel
      ZIPKIN_URL: http://zipkin:9411/api/v1/spans
    depends_on:
      - zipkin
      - redis-queue
  
  zipkin:
    image: openzipkin/zipkin
    ports:
      - 9411:9411

  redis-queue:
    image: redis